"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Http = void 0;
const debug_1 = __importDefault(require("debug"));
const express_1 = __importDefault(require("express"));
const express_async_handler_1 = __importDefault(require("express-async-handler"));
const player_1 = require("./player");
class Http {
    constructor(port, player = new player_1.Player()) {
        this.player = player;
        this.app = express_1.default();
        this.debug = debug_1.default("http");
        this.app.get("/play", express_async_handler_1.default((req, res) => __awaiter(this, void 0, void 0, function* () {
            const url = req.query.url;
            try {
                yield this.player.play(url);
            }
            catch (e) {
            }
            res.send();
        })));
        this.app.get("/stop", express_async_handler_1.default((req, res) => __awaiter(this, void 0, void 0, function* () {
            yield this.player.stop();
            res.send();
        })));
        this.app.get("/status", express_async_handler_1.default((req, res) => __awaiter(this, void 0, void 0, function* () {
            res.json(yield this.player.status());
        })));
        this.app.listen(port, () => {
            this.debug(`Listening on port ${port}`);
        });
    }
    start() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.player.start();
        });
    }
}
exports.Http = Http;
